SystemOrganization addCategory: #'XpProcess-Model'!
SystemOrganization addCategory: #'XpProcess-Component'!
SystemOrganization addCategory: #'XpProcess-Tests'!
SystemOrganization addCategory: #'XpProcess-Login'!
SystemOrganization addCategory: #'XpProcess-Database'!
SystemOrganization addCategory: #'XpProcess-Report'!

WATask subclass: #XpRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Component'!

!XpRootTask commentStamp: 'rga 3/19/2009 17:08' prior: 0!
A XpRootTask is a WATask, so no rendering and a  'go' method.

Instance Variables  <none>

About de #go method:
	XpLoginComponent can yield to 2 responses or results:
		#registerUser  <when somebody hit the 'inscription button'> 
		#user  <when the user loggedIn successfully>

	XpRegisterComponent give also two results:
		#user  <when the user registered successfully>
		'true' <when someone hit the 'cancel button'!

!XpRootTask class methodsFor: 'testing' stamp: 'rga 3/9/2009 14:54'!
canBeRoot
	^ 	true! !

!XpRootTask class methodsFor: 'testing' stamp: 'RGA 10/29/2014 13:13'!
initialize
"XpRootTask initialize"

| application maSession |
	self flag: #modifierSiMagma.	
	maSession := XpSession new.
	application := WAAdmin register: self asApplicationAt: 'XpProcess'	.
	application preferenceAt: #sessionClass put: maSession.
! !

!XpRootTask methodsFor: 'processing' stamp: 'RGA 11/20/2014 07:41'!
go

	| loginAnswer user anXpProcess |
	loginAnswer := self call: XpLoginComponent new.
	loginAnswer = #registerUser
		ifTrue:[ user := self call: XpRegisterComponent new]
		ifFalse:[ user := loginAnswer].
		user ifNotNil:[ "user = (from a successfull registration) or (from a successfull login)"
		self session login: user. 
		self session project: self session database project.
		self session inspect.
		anXpProcess := XpProcessComponent new.
"		anXpProcess resetProject .		self halt.	
"		self call: anXpProcess ]! !

!XpRootTask methodsFor: 'initialization' stamp: 'RGA 10/25/2014 23:41'!
initialize
	super initialize.
! !

WAFileLibrary subclass: #XpLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpLibrary class methodsFor: 'as yet unclassified' stamp: 'rga 3/23/2009 18:00'!
applicationName
	^ 'GDX - Gestion du Dveloppement XP'! !

!XpLibrary class methodsFor: 'as yet unclassified' stamp: 'RGA 10/22/2014 23:11'!
info

	^'  Faites le suivi de votre projet eXtreme Programming avec cette application dveloppe avec 
	 Squeak 4.4  et  Seaside 3.0 .   
	- Le modle est dvelopp avec l''approche "tests driven software".
	- Pour le moment l''image de Squeak sert de Base de Donnes.'! !

!XpLibrary methodsFor: 'accessing' stamp: 'rga 4/2/2009 17:55'!
selectorsToInclude
	^ #(#xpCss )! !

!XpLibrary methodsFor: 'accessing' stamp: 'RGA 11/5/2014 21:54'!
xpCss
	^ '	/*   
		"#" sont des selecteurs de division de page .
		"BODY" sont des selecteurs de type .
		".class-name" sont des selecteurs de classe : 
			exemple:   ".foo"    . */
h1 {
	padding: 1.0em;
	text-align: left ;
	font-size: 1.3em; 
	color: yellow;	
	background-color: darkblue;
	} 
h2, h3, h4, h5, h6 {
	margin: 0px  0px;
	padding:10px 0px;
	}
div, span, table, thead, tfoot, tr, td, th, p, ul, ol, dl, li, dt, dd, blockquote, a, img, br, h1, h2, h3, h4, h5, h6, hr, address, del, ins, pre, object, embed, q, sub, sup, form, label, abbr, acronym, cite, cc, dfn, em, strong, b, i, kbd, samp, var, iframe {
	border:0 solid #9E9A91;
	list-style-type:none;
	padding:0;
	border-collapse: collapse;
	}add
textArea {
	background-color: yellow;
	width: 228px;
	}
table {
	border: 0 solid #9E9A91;
	margin-left: 150px;
	margin-right: 1em;
	width:82%;
	}
tr , even  {
	background-color: lightblue; 
	} 
th  {	
	font:  verdana;
	color: darkblue ;
	font-size: 1em;
	border-color: darkblue;
	padding: 0em 0.5em;
	}
td { 
	border-style:solid; 
	border-width: 1px; 
	font:  verdana;
	background-color: white ;
	padding: 0.1em 0.4em 0.1em;
	}
.presentation {
	position: relative;
	margin-left: 22px;
	margin-top: 22px;
	border-radius: 10px; 
	border-width: thick;
	background-color: lightblue ;
	border-color: darkblue;
	margin-right: 2em;
	padding: 0.5em ;
	height: auto;
	width: 50%;
	font-size: 1em;
	}
.boutonAjouter  {
	margin-left: 120px;
	}
.presentation .info {
	background-color: yellow ;
	margin: 1.5em;
	padding: 1.5em ;
	}

.menu  a	{
	float: left ;
	color: red;
	font-style: italic;
	line-height:2em;
	}
.menu {
	position: absolute;
	top: 100px;
	left: -7px;
	border: 1px solid blue;
	border-radius: 10px; 
	width: 4.8em;
	margin: 1em;
	padding: 1.8em;
	background-color: #FFFF60;
	}
.menuCreation {
	left: 0px;
	border: 1px solid blue;
	border-radius: 10px; 
	width: 84%;
	padding: 0 1em 0 7em;
	background-color: lightgreen
	}
.menuCreation  a	{
	color: red;
	padding: 0 1em ;
	font-style: italic;
	line-height:2em;
	}
.registerComponent {
	position: relative;
	margin-left: 120px;
	margin-top: 22px;
	border-radius: 10px; 
	border-width: thick;
	background-color: yellow ;
	border-color: darkblue;
	padding: 0.5em ;
	height: auto;
	width: 40%;
	font-size: 1em;
	}
.center  {
	margin-top: 14px;
	text-align: center;
	font-size: 1.5em;
	color: red;
	}
.report  {
	margin-top: 8px;
	}
.registerComponent table {
	border-color: darkblue;
	margin-top: 0em;
	margin-left: 1em;
	padding: 0.5em ;
	height: auto;
	width: 90%;
	font-size: 1em;
	}
.reportB {
	padding: 0.5em ;
	width: 44%;
	}

'! !

!ChronologyConstants class methodsFor: '*XpProcess-' stamp: 'rga 3/9/2009 14:35'!
initializeForFrench
	"ChronologyConstants initialize" 	SqueakEpoch := 2415386. 		"Julian day number of 1 Jan 1901" 
	SecondsInDay := 86400.
	SecondsInHour := 3600.
	SecondsInMinute := 60.
	NanosInSecond := 10 raisedTo: 9.
	NanosInMillisecond := 10 raisedTo: 6.
	DayNames := #(Dimanche Lundi Mardi Mercredi Jeudi Vendredi Samedi "Sunday Monday Tuesday Wednesday Thursday Friday Saturday").
		
	MonthNames := #(Janvier Fevrier Mars Avril Mai Juin Juillet Aout Septembre Octobre Novembre Decembre "January February March April May June July
 			August September October November December").
	DaysInMonth := #(31 28 31 30 31 30 31 31 30 31 30 31).
! !

WAComponent subclass: #XPTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Component'!

!XPTestComponent methodsFor: 'as yet unclassified' stamp: 'RGA 10/21/2014 08:39'!
renderContentOn: html
html heading: self session. html anchor
callback: [ self call: (WAInspector on: self session) ]; with: 'Inspect current session'! !

WAComponent subclass: #XpLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpLoginComponent commentStamp: 'rga 3/19/2009 15:11' prior: 0!
A XpLoginComponent is xxxxxxxxx.

Instance Variables
	email:		<initialized in renderTextInputOn:>
	messageComponent:		<to inform the user of what is going on with the application>
	password:		<initialized in renderPasswordInputOn:>

email
	- xxxxx

messageComponent
	- xxxxx

password
	- xxxxx
!

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
email
	^ email! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 15:07'!
email: anObject

	email := anObject! !

!XpLoginComponent methodsFor: 'testing' stamp: 'rga 3/9/2009 16:47'!
hashPassword: aString

	aString
		ifEmpty: [^0]
		ifNotEmpty:[ ^ SecureHashAlgorithm  new hashMessage: aString]! !

!XpLoginComponent methodsFor: 'initialization' stamp: 'rga 3/19/2009 15:06'!
initialize

	super initialize.! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 15:15'!
label

	^ 'S.V.P. Entrez votre adresse de courriel et votre mot de passe ...!!'! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 16:44'!
loginFailed

	self messageComponent errorMessage: 'Login failed - - Please  retry !!'.
! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:14'!
messageComponent

	^ messageComponent ifNil:[ messageComponent := XpMessageComponent new]! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:16'!
messageComponent: aComponent

	 messageComponent := aComponent! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
password
	^ password! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
password: anObject
	password := anObject! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/9/2009 16:49'!
registerUser

	self answer: #registerUser! !

!XpLoginComponent methodsFor: 'rendering' stamp: 'RGA 10/21/2014 11:55'!
renderContentOn: html 
	html div
		class: 'presentation';
		with: 
			[ self renderInviteOn: html.
			html 
				text: self label.
			html
				render: self messageComponent;
				form: 
					[ self
						renderingSessionOn: html;
						renderTextInputOn: html;
						renderPasswordInputOn: html;
						renderLoginButtonOn: html;
						renderSignUpButtonOn: html ] ]! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 4/5/2009 21:54'!
renderInviteOn: html 
	html heading: XpLibrary applicationName.
	html div
		class: 'info';
		with: 
			[ html 
				text: XpLibrary info ].
! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/19/2009 12:10'!
renderLoginButtonOn: html

	html submitButton 
		callback: [ self validateLogin];
		text: 'Connexion'! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/9/2009 16:39'!
renderPasswordInputOn: html

	html passwordInput 
		callback:[ :value | self password:  (self hashPassword: value)];
		value: ''! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 4/2/2009 17:55'!
renderSignUpButtonOn: html 
	html
		break;
		break;
		break.
	html submitButton
		callback: [ self registerUser ];
		text: 'S''inscrire   ' , XpLibrary applicationName! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/19/2009 12:14'!
renderTextInputOn: html

	html break .
	html textInput
		on: #email of: self;
		value: ''.
	html space ! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'RGA 10/23/2014 09:10'!
renderingSessionOn: html
"testing purpose"
	html heading: self session. 
	"html anchor
		callback: [ self call: (WAInspector on: self session) ]; with: 'Inspect current session'"! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 16:23'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue:[ self answer: user]
		ifFalse:[ self loginFailed ]! !

WAComponent subclass: #XpMenuComponent
	instanceVariableNames: 'currentMenu entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Component'!

!XpMenuComponent commentStamp: 'rga 2/27/2009 22:57' prior: 0!
A XPMenuComp is xxxxxxxxx.

Instance Variables
	currentMenu:		<Object>

currentMenu
	- keep the current selected menu item
!

!XpMenuComponent methodsFor: 'as yet unclassified' stamp: 'rga 2/27/2009 23:57'!
addEntry: aString withAction: aBlock
"Each entrie is an association key -> valu"
	^ self entries add: ( aString -> aBlock)! !

!XpMenuComponent methodsFor: 'accessing' stamp: 'rga 2/27/2009 23:18'!
entries
	^ entries! !

!XpMenuComponent methodsFor: 'initialization' stamp: 'rga 2/27/2009 23:16'!
initialize

	super initialize.
	entries := OrderedCollection new.! !

!XpMenuComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 12:32'!
renderContentOn: html

	self entries
			do:[ :entry | 
				html anchor
					callback: entry value ;
					with: entry key]
				separatedBy: [html space]! !

WAComponent subclass: #XpMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpMessageComponent methodsFor: 'as yet unclassified' stamp: 'rga 3/20/2009 16:39'!
errorMessage: aString
	self
		messageString: 'Erreur: ' , aString ;
		messageType: 'error' ;
		wasShown: false.
! !

!XpMessageComponent methodsFor: 'as yet unclassified' stamp: 'rga 3/10/2009 09:53'!
infoMessage: aString
	self
		messageString: 'Info: ' , aString ;
		messageType: 'info' ;
		wasShown: false! !

!XpMessageComponent methodsFor: 'initialization' stamp: 'rga 3/10/2009 09:50'!
initialize

	super initialize.
	self wasShown: true! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageString
	^ messageString! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageString: anObject
	messageString := anObject! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageType
	^ messageType! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageType: anObject
	messageType := anObject! !

!XpMessageComponent methodsFor: 'rendering' stamp: 'rga 3/10/2009 09:54'!
renderContentOn: html

	self wasShown ifTrue: [ ^self].
	html div
		class: self messageType , 'Message' ;
		with: self messageString.! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
wasShown
	^ wasShown! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #XpProcessComponent
	instanceVariableNames: 'model parent verticalMenu horizontalMenu report editors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Component'!

!XpProcessComponent commentStamp: 'rga 2/26/2009 14:44' prior: 0!
A XPProcessComp is the main component of the application. .

Instance Variables
	model:		<Object>

model
	- an XPProject
!

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/3/2014 21:26'!
addCommandsOn: aReport 
	aReport
		addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #editObject:
					text: 'diter';
				yourself).
		self flag: #revoir .
	"	addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #associateObject:
					text: 'Associer...';
				yourself);"
		aReport addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #removeObject:
					text: 'Effacer';
				yourself)! !

!XpProcessComponent methodsFor: 'rendering' stamp: 'RGA 11/6/2014 23:04'!
arenderContentOn: html 
	html div
		class: 'menu';
		with: [ html render: verticalMenu ].
	html div with: 
		[ html heading: 'L''utilisateur est : ' , self session user hisName capitalized.
		  html div
			class: 'menuCreation' ;
			with: [html render: horizontalMenu].
	html div
		class: 'center';
    		with: self report title.	  
	html render: self report].
! !

!XpProcessComponent methodsFor: 'private' stamp: 'RGA 11/8/2014 23:39'!
asCommand: anObject 
	"For example if anObject= aXpMember, the method will return:	#members "
	| mot |
	mot := anObject class name.
	mot := mot copyFrom: 3 to: mot size.
	^ mot := (mot withFirstCharacterDownshifted , 's') asSymbol! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 1/6/2010 22:40'!
associateObject: anObject 

	self call: self demande
! !

!XpProcessComponent methodsFor: 'rendering' stamp: 'RGA 11/7/2014 02:16'!
brenderContentOn: html 
	html div
		class: 'menu';
		with: [ html render: verticalMenu ].
	html div with: 
		[ html heading: 'L''utilisateur est : ' , self session user hisName capitalized.
		  html div
			class: 'menuCreation' ;
			with: [html render: horizontalMenu].
	self  report: (self renderMembersReportOn: html)].
	self report.
! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/3/2014 21:30'!
buildReportFor: anObject
"Create a report for that kind of object"
	| kob |
	kob := self asCommand: anObject.
	^ self report rows: (model perform: kob)! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 2/8/2010 15:01'!
children

	^ Array  with: self verticalMenu  with: self report  with: self horizontalMenu! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 10/23/2014 15:25'!
createNewComponentFrom: aClass 
	| obj |
	obj := self call: aClass new descriptionEdit asComponent addValidatedForm.
	obj notNil ifTrue:
		[ model addToMembers: obj.
		self refreshReport.
		self save ]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 14:42'!
createNewIteration
	| answer  obj |
	self iterationsReport.
	obj := XpIteration new.
	"set the project of the object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addToIterations:  answer .
		self iterationsReport.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 14:42'!
createNewMember
	| answer obj |
	self membersReport. 
	obj := XpMember new.
	"set the project of the object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil: 
		[ "set the project of the XpMember object"
		self model addToMembers: answer.
		self membersReport.
		self save ]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 14:41'!
createNewRelease
		| answer  obj |
	" on appelle #releasesReport pour tre dans le bon contexte car les boutons de cration peuvent tre utiliss peut importe le rapport qui est affich."
	self releasesReport.
	obj := XpRelease  new.
	"set the project of the object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addToReleases:  answer .
		self releasesReport.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 13:19'!
createNewTask
	
| answer  obj |
	
	self tasksReport.
	obj := XpTask new.
	"set the project of the XpTask object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[ 
		self model addToTasks: answer .
		self tasksReport.
		self save].

! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 14:43'!
createNewTest
	
| answer  obj |
	self testsReport.
	obj := XpTest  new.
	"set the project of the object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addToTests: answer .
		self testsReport.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'RGA 11/6/2014 14:44'!
createNewUseCase
	
| answer  obj |
	self useCasesReport. 
	obj := XpUseCase  new.
	"set the project of the object"
	obj project: model.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[ 		
		self model addToUseCases: answer .
		self useCasesReport.
		self save]! !

!XpProcessComponent methodsFor: 'actions' stamp: 'RGA 11/20/2014 09:44'!
cssClassFor: anObject

	| myDesc |
	editors 
		at: anObject
		ifAbsentPut: [ anObject descriptionEdit ].
		myDesc cssClass: 'reportB'.
! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'rga 1/4/2010 21:41'!
dataTest

	model newMember ; newMember .
	model newTask ; newTask.
	model newRelease ; newRelease.
	model newTest ; newTest.
	model newUseCase ; newUseCase.
	model newIteration ; newIteration .
! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'rga 1/6/2010 22:40'!
demande

	^ (WAComponent inform: 'Pas disponible pour les membres').! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 10/22/2014 23:18'!
descriptionIterationEdit
" This is for dynamic description. i.e : when we want to add something 'on the spot' to an already defined description (Magritte only). "
	| descri |
	descri := XpIteration  magritteDescription copy.
	(descri children at: 2) options: (  model listNames: model releases) asArray.
	^ descri.
! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 10/22/2014 23:19'!
descriptionReleaseEdit
" This is for dynamic description. i.e : when we want to add something 'on the spot' to an already defined description (Magritte only). "
	| descri |
	descri := XpRelease  magritteDescription copy.
	(descri children at: 2) options:  (model listNames: model iterations) asArray.
	^ descri.
! !

!XpProcessComponent methodsFor: 'editor' stamp: 'RGA 11/4/2014 12:08'!
editObject: anObject 
	| obj myDesc component |
	myDesc := editors 
		at: anObject
		ifAbsentPut: [ anObject descriptionEdit ].
	myDesc cssClass: 'reportB'.
	component := (myDesc asComponentOn: anObject) addValidatedForm. 
	obj := self call: component.
	obj notNil ifTrue: [  
		self buildReportFor: anObject.
		self save ]! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:06'!
horizontalMenu
	^ horizontalMenu! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:06'!
horizontalMenu: anObject
	horizontalMenu := anObject! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'RGA 11/6/2014 22:12'!
initialize
"self initialize"
	super initialize.
	model := self session database project.
	ChronologyConstants initializeForFrench.
	editors := Dictionary new.
	self verticalMenu: XpMenuComponent new.
	self horizontalMenu: XpMenuComponent new.
	self
		initializingVerticalMenu;
		initializingHorizontalMenu;
"		dataTest;   "		
		membersReport
	

! !

!XpProcessComponent methodsFor: 'menu' stamp: 'RGA 11/7/2014 23:57'!
initializingHorizontalMenu

	self horizontalMenu
			addEntry: 'Nouveau membre'
				withAction: [  self createNewMember  ];
			addEntry: 'Nouveau livrable'
				withAction: [  self createNewRelease  ];
			addEntry: 'Nouvelle itration'
				withAction: [  self createNewIteration   ];			
			addEntry: 'Nouveau cas'
				withAction: [  self createNewUseCase  ];
			addEntry: 'Nouvelle tche'
				withAction: [  self createNewTask  ];
			addEntry: 'Nouveau test'
				withAction: [  self createNewTest  ];
	
			addEntry: 'DCONNEXION'
				withAction: [ self session logout. self answer ];
			yourself! !

!XpProcessComponent methodsFor: 'menu' stamp: 'RGA 11/7/2014 23:44'!
initializingVerticalMenu
	self verticalMenu
		addEntry: 'Membres'
			withAction: [ self membersReport ];
		addEntry: 'Livrables'
			withAction: [ self releasesReport ];
		addEntry: 'Itrations'
			withAction: [ self iterationsReport ];
		addEntry: 'Cas...'
			withAction: [ self useCasesReport ];
		addEntry: 'Tches'
			withAction: [ self tasksReport ];
		addEntry: 'Tests'
			withAction: [ self testsReport ];
		yourself! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:21'!
iterationsReport
	"We eliminate the field we dont want in our report, here it is :
	note. See reject:"
	| choosedSelectors iter |
	iter := model iterations isEmpty
				ifTrue: [XpIteration new]
				ifFalse: [model iterations anyOne].
	choosedSelectors := iter magritteDescription
				reject: [:each | #(#note ) includes: each accessor selector].
	self
		report: (MAReportXp  rows: model iterations description: choosedSelectors).
	self report title: 'Les Itrations'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:21'!
membersReport
	"Not use: tasks useCases. We eliminate the fields we dont want
	in our report, here it is : email password endDate startDate
	note. See reject: below"
	| choosedSelectors |
	choosedSelectors := XpMember new magritteDescription
				reject: [:each | #(#email #password #endDate #startDate #note ) includes: each accessor selector].
	self
		report: (MAReportXp rows: model members description: choosedSelectors).
	self report title: 'Les Membres'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 6/19/2009 15:01'!
model
"see initialization"
	^model! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 12:35'!
parent
	^ parent! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 12:35'!
parent: anObject
	parent := anObject! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/6/2014 22:19'!
refreshMembersReport
	self report rows: model members! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'rga 1/3/2010 04:13'!
refreshReport
	self report rows: model members! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:21'!
releasesReport
	| choosedSelectors anObject |
	anObject := model releases isEmpty
				ifTrue: [XpRelease new]
				ifFalse: [model releases anyOne].
	choosedSelectors := anObject magritteDescription
				reject: [:each | #(#note ) includes: each accessor selector].
	self
		report: (MAReportXp rows: model releases description: choosedSelectors).
	self report title: 'Les Livrables'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'private' stamp: 'RGA 11/7/2014 22:47'!
removeObject:  anObject

	| aMethod objects |
	anObject removeSelf .
	aMethod := self  asCommand: anObject.
	objects := model perform: aMethod.
	objects remove: anObject ifAbsent:[].
	self save .
	self buildReportFor: anObject.

	
	! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'rga 3/28/2009 22:42'!
renderCheckboxWith: anIteration on: html

	| updater  |
	updater := html updater
		id: 'list' ;
		 callback: [ :renderer | 
			anIteration completed: anIteration completed not.
			renderer render: self listComponent] ;
		yourself.
	html checkbox
		onClick: updater ;
		value: anIteration isCompleted! !

!XpProcessComponent methodsFor: 'rendering' stamp: 'RGA 11/20/2014 17:23'!
renderContentOn: html 
	html div
		class: 'menu';
		with: [ html render: verticalMenu ].
	html div with: 
		[ html heading: 'L''utilisateur est : ' , self session user hisName capitalized.
		  html div
			class: 'menuCreation' ;
			with: [html render: horizontalMenu].
	html div
		class: 'center';
    		with: self report title.	  
	html render: self report].
	html break.
"	self setCssClassFor: anObject.
	html anchor
        callback: [ self showDetails ];
        with: 'Dtails...'."
! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'rga 3/23/2009 10:53'!
renderInPlaceEditorWith: aMember on: html

	| editor |
	editor := html inPlaceEditor
		cancelControl: false ;
		triggerInPlaceEditor: [ :value | aMember hisName: value] ;
		callback: [ :renderer | renderer render: aMember hisName] ;
		yourself.
	html div
		script: editor ;
		with: aMember hisName! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 11/5/2014 22:15'!
renderMember: aMember on: html
	| myReport |
	html div
		class: 'reportB'.
		myReport := self buildReportFor: aMember.
		html render: myReport.
		self save .! !

!XpProcessComponent methodsFor: 'rendering' stamp: 'RGA 11/7/2014 02:10'!
renderMembersReportOn: html

	| aCollection |
	html div
		class: 'center'; with:'Liste des Membres'.
	aCollection := model project members.
	aCollection isNil 
		ifTrue:[html text: 'ya rien']
		ifFalse:[
			 html table: [
					html tableRow: [ 
		            	html tableHeading:  'NOM' .
		           	html tableHeading: 'Role' .
		            	html tableHeading: 'Courriel'.
					html tableHeading:'Mot de passe'.
		            	html tableHeading: 'Tches'.
					html tableHeading: 'Charge'.
					html tableHeading: 'Ralises'.	]	.	
				aCollection do:[:member| 
		       		html tableRow: [ 
		            	html tableHeading:  member hisName .
		           	html tableData: member role .
		            	html tableData: member email.
					html tableData: member password.
		            	html tableData: member nbTasks.
					html tableData: member load.
					html tableData: member done.				
					 ]  
]]]! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 11/5/2014 22:35'!
renderTaskOn: html
	| myReport |
	
	html div  
		class: 'reportB'; 
		with: [
			html select.
			html render: myReport.
			self save .]	! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/22/2009 10:20'!
report
	^ report! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/22/2009 10:20'!
report: anObject
	report := anObject! !

!XpProcessComponent methodsFor: 'private' stamp: 'RGA 11/7/2014 18:39'!
resetProject
" To create aProject and to set a database properly.  
The second time you send this message, your old database will be erase/replace by a new empty one. 
To make a reset see XpRootTask #go "
 | aProject |
	aProject := XpProject new hisName: 'PremierProjet'.
	self session database project: aProject.
	self session project: aProject.
! !

!XpProcessComponent methodsFor: 'actions' stamp: 'RGA 11/4/2014 11:48'!
save

		"Is it necessary to make a snapshot so often?
		"
		self flag: #revoir.
		self session database saveImage.
		self flag: #modifierSiMagma
! !

!XpProcessComponent methodsFor: 'actions' stamp: 'RGA 11/20/2014 09:45'!
setCssClassFor: anObject

	| myDesc |
	myDesc := editors 
		at: anObject
		ifAbsentPut: [ anObject descriptionEdit ].
		myDesc cssClass: 'reportB'.
! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'rga 3/31/2009 17:39'!
showProgrammers

	self filterBlock: [:item | item = 'programmeur'];
 	refreshReport.! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:21'!
tasksReport
	| choosedSelectors anObject |
	anObject := model tasks isEmpty
				ifTrue: [XpTask new]
				ifFalse: [model tasks anyOne].
	choosedSelectors := anObject magritteDescription
				reject: [:each | #(#endDate #startDate #note #owner ) includes: each accessor selector].
	self
		report: (MAReportXp rows: model tasks description: choosedSelectors).
	self report title: 'Les Tches'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:22'!
testsReport
	| choosedSelectors aTest |
	aTest := model tests isEmpty
				ifTrue: [XpTest new]
				ifFalse: [model tests anyOne].
	choosedSelectors := aTest magritteDescription
				reject: [:each | #(#endDate #startDate #note ) includes: each accessor selector].
	self
		report: (MAReportXp rows: model tests description: choosedSelectors).
	self report title: 'Les Tests'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'report' stamp: 'RGA 11/20/2014 17:22'!
useCasesReport
	| choosedSelectors aCase |
	aCase := model useCases isEmpty
				ifTrue: [XpUseCase new]
				ifFalse: [model useCases anyOne].
	choosedSelectors := aCase magritteDescription
				reject: [:each | #(#startDate #endDate #note ) includes: each accessor selector].
	self
		report: (MAReportXp rows: model useCases description: choosedSelectors).
	self report title: 'Les Cas d''Utilisation'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:05'!
verticalMenu
	^ verticalMenu! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:05'!
verticalMenu: anObject
	verticalMenu := anObject! !

!XpProcessComponent methodsFor: 'experiment' stamp: 'RGA 10/22/2014 23:02'!
xdescriptionEdit
" This is for dynamic description. i.e : when we want to add something 'on the spot' to an already defined description (Magritte only).  Here we want to add 'ID' to a description"
	^ self magritteDescription copy
		add: (MANumberDescription new
			selectorAccessor: #id ;
			label: 'ID' ;
			priority: 5 ;
			beReadonly  ;
			yourself ).
! !

WAComponent subclass: #XpRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:33'!
hashPassword: aString

	aString
		ifEmpty: [ ^ 0]
		ifNotEmpty:[ ^ SecureHashAlgorithm new hashMessage: aString]! !

!XpRegisterComponent methodsFor: 'initialization' stamp: 'rga 3/19/2009 12:37'!
initialize

	super initialize.
	self user: XpMember new! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:35'!
messageComponent

	^ messageComponent ifNil:[ 	messageComponent := XpMessageComponent new.]! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:35'!
messageComponent: anObject

	messageComponent := anObject! !

!XpRegisterComponent methodsFor: 'action' stamp: 'RGA 10/24/2014 10:34'!
registerUser
	self flag: #revoir.
	self user hisName isEmptyOrNil
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  choisir un nom d''usager!!'].
	self user email isEmptyOrNil
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  entrez votre courriel!!'].
	"(self session findUserByEmail: self user email)
		ifNotNil:[ ^ self messageComponent 
			errorMessage:' Cette adresse de courriel est dj inscrite!!']."
	self user password = 0
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  choisir un mot de passe!!'].
	self user password = self repeatedPassword
		ifFalse:[ ^ self messageComponent
			infoMessage: 'Votre mot de passe rpt ne concorde pas!!']. 
	self session database addUser: self user.
	self answer: self user

! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 17:12'!
renderCancelButtonOn: html

	html submitButton 
		callback: [ self answer: nil] ;
		text: 'Annuler'! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 4/3/2009 11:26'!
renderContentOn: html

	html div
		class: 'registerComponent';
		with:[
			html
				heading: 'Inscription' ;
				render: self messageComponent ;
				form: [
					html table: [
						self
							renderUserNameTextInputOn: html ;
							renderEmailTextInputOn: html ;
							renderPasswordTextInputOn: html ;
							renderRepeatedPasswordTextInputOn: html .
						html tableRow: [
							html
								tableData ;
								tableData:[ 
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html] ] ] ] ]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:41'!
renderEmailTextInputOn: html 

	html tableRow: [
		html
			tableData:  'Votre Courriel' ;
			tableData: [
				html textInput
					callback:[ :value | self user email: value ] ;
					value: self user email]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:45'!
renderPasswordTextInputOn: html

	html tableRow: [
		html
			tableData:  'Mot de passe' ;
			tableData: [
				html passwordInput 
					callback:[ :value | 
						self user password: (self hashPassword: value)] ]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:47'!
renderRepeatedPasswordTextInputOn: html

	html tableRow: [
		html
			tableData:  'Rpter votre mot de passe' ;
			tableData: [
				html passwordInput 
					callback:[ :value | 
						self  repeatedPassword: (self hashPassword: value)] ]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 17:11'!
renderSubmitButtonOn: html

	html submitButton 
		callback:[ self registerUser] ;
		text: 'Inscrire'! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 11:05'!
renderUserNameTextInputOn: html

	html tableRow: [
		html
			tableData:  'Nom de l''usager' ; 
			tableData: [
				html textInput
					callback: [ :value | self user hisName: value] ;
					value: self user hisName]]! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
repeatedPassword

	^ repeatedPassword! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
repeatedPassword: anObject

	repeatedPassword := anObject! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
user

	^ user! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
user: anObject

	user := anObject! !

WASession subclass: #XpSession
	instanceVariableNames: 'user database project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:38'!
database
	^ database! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:38'!
database: anObject
	database := anObject! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:37'!
findUserByEmail: eMail

	^ self  database findUserByEmail: eMail! !

!XpSession methodsFor: 'initialization' stamp: 'RGA 11/7/2014 18:57'!
initialize

	super initialize.
	self database: XpImageDB new.! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:40'!
isLoggedIn 

	^ self user notNil! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:38'!
login: aUser

	self user: aUser! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:39'!
logout 

	self user: nil! !

!XpSession methodsFor: 'accessing' stamp: 'RGA 10/29/2014 13:31'!
project
	^ project! !

!XpSession methodsFor: 'accessing' stamp: 'RGA 10/29/2014 13:30'!
project: anObject
	project := anObject! !

!XpSession methodsFor: 'initialization' stamp: 'rga 3/19/2009 09:19'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [ ^ WAResponse  new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!XpSession methodsFor: 'initialization' stamp: 'rga 3/18/2009 21:41'!
unregistered

	self database disconnect.
	super unregistered! !

!XpSession methodsFor: 'initialization' stamp: 'rga 4/2/2009 17:55'!
updateRoot: anHtmlRoot 
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: XpLibrary applicationName! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/9/2009 14:38'!
user
	^ user! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/9/2009 14:38'!
user: anObject
	user := anObject! !

Object subclass: #XpCommun
	instanceVariableNames: 'id hisName note owner project startDate endDate history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpCommun commentStamp: 'RGA 10/29/2014 12:11' prior: 0!
A XpCommun is xxxxxxxxx.

Instance Variables
	endDate:		<Object>
	hisName:		<aString>
	history:		<Object>
	id:		<Object>
	note:		<Object>
	project:		<Object>
	startDate:		<Object>

endDate
	- xxxxx

hisName
	- xxxxx

history
	- xxxxx

id
	- xxxxx

note
	- xxxxx

project
	- xxxxx

startDate
	- xxxxx
!

!XpCommun methodsFor: 'private' stamp: 'RGA 11/6/2014 19:16'!
asCommand: anObject 
	"For example if anObject= aXpMember, the method will return:
	#members "
	| mot |
	mot := anObject class name.
	mot := mot copyFrom: 3 to: mot size.
	^ mot :=( mot withFirstCharacterDownshifted , 's') asSymbol! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 10/29/2014 12:26'!
defaultEndDate
"Contrat d'un an"
	^ Date new addMonths: 12! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 11/7/2014 18:52'!
defaultName
	^ 'Sans nom'! !

!XpCommun methodsFor: 'defaults' stamp: 'rga 1/6/2011 21:38'!
defaultNote
	^ '...  '! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 10/28/2014 13:55'!
defaultStartDate

	^Date today ! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 10/22/2014 23:13'!
descriptionEdit
" This is for dynamic description. i.e : when we want to add something 'on the spot' to an already defined description (Magritte only).  Here we want to add 'ID' to a description"
	^ self magritteDescription copy
		add: (MANumberDescription new
			selectorAccessor: #id ;
			label: 'ID' ;
			priority: 5 ;
			beReadonly  ;
			yourself  )! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:39'!
endDate
	^ endDate! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:20'!
endDate: anObject
	endDate := anObject! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:39'!
hisName
	^ hisName! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/5/2009 10:28'!
hisName: aString
	hisName := aString! !

!XpCommun methodsFor: 'lazzy-initialisation' stamp: 'test 2/26/2009 12:52'!
history
	^ history ifNil: [ history := OrderedCollection new ]! !

!XpCommun methodsFor: 'accessing' stamp: 'test 2/26/2009 12:52'!
history: anArray 
	self history add: anArray! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 3/23/2009 17:08'!
id
	^ id! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 3/23/2009 17:08'!
id: anObject
	id := anObject! !

!XpCommun methodsFor: 'initialization' stamp: 'rga 1/6/2011 21:38'!
initialize

	self hisName: self defaultName.
	self note: self defaultNote.
	self startDate: self defaultStartDate.
	self endDate: self defaultEndDate.! !

!XpCommun methodsFor: 'list' stamp: 'RGA 11/7/2014 19:15'!
iterationsNamesList
	| aCollection  |
	self project notNil  ifTrue:[
	aCollection :=self project iterations .
^ aCollection collect: [:iteration | iteration  hisName ]	
		]! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:00'!
magritteDescriptionEndDate
	<magritteDescription>
	^ MADateDescription  new
		selectorAccessor: #endDate ;
		label: 'Fin' ;
		priority: 50 ;
		default:  Date new;
		yourself! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:00'!
magritteDescriptionHisName
	 	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #hisName ;
		label: 'Nom' ;
		priority: 10 ;
		beRequired  ;
		addCondition: [ :value | (value size <= 24)]
		labelled: 'Le nom est trop long' ;
		yourself! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:00'!
magritteDescriptionNote
	<magritteDescription>	
	^ MAMemoDescription  new
		selectorAccessor: #note ;
		label: 'Note' ;
		priority: 100 ;
		default: '' ;
		yourself! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:01'!
magritteDescriptionStartDate
		<magritteDescription>
	^ MADateDescription  new
		selectorAccessor: #startDate ;
		label: 'Dbut' ;
		priority: 40 ;
		default:  Date new;
		yourself! !

!XpCommun methodsFor: 'list' stamp: 'RGA 11/7/2014 19:17'!
membersNamesList
	| aCollection  |
	self project notNil  ifTrue:[
	aCollection :=self project members.
	^ aCollection collect: [:membre | membre  hisName]]! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:36'!
note
	^ note ! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/5/2009 10:35'!
note: aString
	note := aString! !

!XpCommun methodsFor: 'lazzy-initialisation' stamp: 'RGA 10/29/2014 12:51'!
owner
	^ owner
		ifNil: [ owner := XpMember bidon]! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 10/29/2014 12:54'!
owner: aXpMember
	owner := aXpMember! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 10/29/2014 12:38'!
ownerName
	^ self owner hisName! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 10/29/2014 13:37'!
ownerName: aName
	^ self owner hisName: aName! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:22'!
project
	^ project! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:22'!
project: anObject
	project := anObject! !

!XpCommun methodsFor: 'testing' stamp: 'RGA 11/8/2014 23:00'!
projectExist
	^ project notNil! !

!XpCommun methodsFor: 'list' stamp: 'RGA 11/7/2014 19:17'!
releasesNamesList
	| aCollection  |
	self project notNil  ifTrue:[
	aCollection :=self project releases  .
	^ aCollection collect: [:aRelease | aRelease   hisName ]	
		]! !

!XpCommun methodsFor: 'private' stamp: 'RGA 11/7/2014 23:14'!
removeSelf
	self subclassResponsibility! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:40'!
startDate
	^ startDate! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:20'!
startDate: anObject
	startDate := anObject! !

!XpCommun methodsFor: 'list' stamp: 'RGA 11/7/2014 19:18'!
useCasesNamesList
	| aCollection  |
	self project notNil  ifTrue:[
	aCollection :=self project useCases.
	^aCollection collect: [:case | case  hisName ]]! !

XpCommun subclass: #XpIteration
	instanceVariableNames: 'capacityPts useCases release'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpIteration commentStamp: 'rga 1/9/2011 16:50' prior: 0!
A XpIteration is used to be part of a XpRelease and is composed of useCases .

Instance Variables
	capacityPts:		<Object>
	release:		<Object>
	useCases:		<Object>

capacityPts
	- xxxxx

release
	- xxxxx

useCases
	- xxxxx
!

!XpIteration methodsFor: 'private-accessing' stamp: 'RGA 11/7/2014 18:18'!
addSelfToRelease

	"peut etre changer OrderedCollection par Set pour viter les doubles?
	Autres faons de faire?"self flag: #revoir.
	self release iterations: self .
	! !

!XpIteration methodsFor: 'accessing' stamp: 'rga 2/17/2009 12:07'!
capacityPts
	^ capacityPts! !

!XpIteration methodsFor: 'accessing' stamp: 'rga 2/17/2009 12:07'!
capacityPts: anObject
	capacityPts := anObject! !

!XpIteration methodsFor: 'associations' stamp: 'RGA 10/23/2014 09:02'!
changeReleaseTo: aRelease
	self flag: #revoir." don''t understand why we do what is below"
	self release removeIteration: self.
	self release: aRelease! !

!XpIteration methodsFor: 'actions' stamp: 'rga 1/9/2011 16:25'!
choixRelease


	^ Set newFrom: project releases! !

!XpIteration methodsFor: 'accessing' stamp: 'RGA 11/19/2014 17:03'!
done
"for display purpose"
		self load  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: 
			[^(self donePts  / self load *100) truncated asString , ' % ']! !

!XpIteration methodsFor: 'calcul' stamp: 'RGA 11/19/2014 16:50'!
donePts

	self useCases ifEmpty:[^0 ].
	^self useCases inject: 0 into:[ :tot :ea | tot + ea donePts].

! !

!XpIteration methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:14'!
initUseCases

	useCases := OrderedCollection new.! !

!XpIteration methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:13'!
initialize

	
	super initialize.	
	self initUseCases.
	self capacityPts: 0.
	"self release: nil. "
! !

!XpIteration methodsFor: 'calcul' stamp: 'RGA 11/8/2014 01:14'!
load

	| total 	|
	self useCases isEmptyOrNil  ifTrue:[^0].
	total := self useCases inject: 0 into:[ :tot :ea | tot + ea estimatedPts].
	^total! !

!XpIteration methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 00:30'!
magritteDescriptionCapacityPts
	<magritteDescription>	
	^ MANumberDescription  new
		selectorAccessor: #capacityPts ;
		label: 'Capacit' ;
		priority: 70 ;
		default: 0 ;
		yourself! !

!XpIteration methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:45'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #done ;
		label: '% Ralis' ;
		priority: 80 ;
		beReadonly ;
		yourself
! !

!XpIteration methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:43'!
magritteDescriptionLoad
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #load ;
		label: 'Charge' ;
		priority: 75 ;
		beReadonly ;
		yourself
! !

!XpIteration methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 00:45'!
magritteDescriptionRelease
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #releaseName;
		label: 'Livrable' ;
		priority: 20 ;
		options: self releasesNamesList;
		default: '' ;
		yourself
		
	
! !

!XpIteration methodsFor: 'actions' stamp: 'rga 1/7/2011 15:42'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self capacityPts
		with: self load
		with: self done
		with: self ptsLeft	! !

!XpIteration methodsFor: 'calcul' stamp: 'rga 1/6/2011 22:15'!
ptsLeft
	^ self load - self done! !

!XpIteration methodsFor: 'associations' stamp: 'rga 1/6/2011 22:16'!
release
	
		^release
		 ! !

!XpIteration methodsFor: 'associations' stamp: 'RGA 11/7/2014 23:54'!
release: aRelease
	
	| releaseObject |
	releaseObject := self project releases.
	releaseObject isEmptyOrNil 
		ifFalse: [releaseObject := releaseObject anyOne.
	releaseObject:= (self project  find: releaseObject  byName: aRelease ). 	
	releaseObject notNil
		ifTrue: [release := releaseObject.
					self addSelfToRelease]]! !

!XpIteration methodsFor: 'accessing' stamp: 'rga 1/6/2011 22:35'!
releaseName
	
		^ self release ifNotNil:[ self release hisName]
		 ! !

!XpIteration methodsFor: 'accessing' stamp: 'RGA 11/8/2014 23:10'!
releaseName: aName
	
	| releaseObject  |
	self projectExist ifTrue:[
		releaseObject := self project releases anyOne.
		releaseObject := (self project  find: releaseObject  byName: aName)].
		releaseObject ifNotNil: [ 
			releaseObject iterations:  self.
			release := releaseObject]! !

!XpIteration methodsFor: 'accessing' stamp: 'rga 12/10/2009 14:29'!
releases

	^project releases! !

!XpIteration methodsFor: 'removing' stamp: 'RGA 11/9/2014 21:22'!
removeSelf
	
	| lesIterations |
	lesIterations := project iterations. 
	lesIterations isEmptyOrNil 
		ifFalse:[ lesIterations remove: self ifAbsent:[]]! !

!XpIteration methodsFor: 'removing' stamp: 'rga 1/6/2011 22:31'!
removeUseCase: aUCase
	self useCases remove: aUCase.! !

!XpIteration methodsFor: 'associations' stamp: 'rga 2/17/2009 12:07'!
useCases
	^ useCases! !

!XpIteration methodsFor: 'associations' stamp: 'rga 1/6/2011 22:31'!
useCases: aUCase
	^ self useCases add: aUCase.! !

XpCommun subclass: #XpMember
	instanceVariableNames: 'role tasks useCases email password descriptions'
	classVariableNames: 'Bidon'
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpMember commentStamp: 'RGA 10/29/2014 12:01' prior: 0!
A XpMember is : people member of a project. Member may be assignedTo: (0/n) tasks or\and (0/n) tests

Instance Variables
	email:		<aString>
	password:		<aString>
	role:		<aString>
	tasks:		<an orderedCollection of XpTasks, empty at first>
	useCases:		<an orderedCollection of  XpUseCases empty at first>

email
	- xxxxx

password
	- xxxxx

role
	- These are predefined roles. Look class side 'descriptionRole'

tasks
	- xxxxx

useCases
	- xxxxx
class variable:

Bidon 
	- anXpMember bidon to be use when there is no owner yet assign
	!

!XpMember class methodsFor: 'accessing' stamp: 'RGA 10/29/2014 12:02'!
bidon
	"to be instantiate once "
	Bidon ifNil: [Bidon := XpMember new hisName: 'bidon'].
	^Bidon! !

!XpMember methodsFor: 'defaults' stamp: 'rga 1/6/2011 21:54'!
defaultRole
	^ 'Programmeur-Analyste'! !

!XpMember methodsFor: 'calcul' stamp: 'RGA 11/19/2014 17:07'!
done
"for display purpose"
		self load  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: 
			[^(self donePts  / self load *100) truncated asString , ' % ']! !

!XpMember methodsFor: 'calcul' stamp: 'RGA 11/19/2014 17:08'!
donePts
	| total allTasks |

	self project ifNil:[^0].
	allTasks := self  tasks.
	allTasks  ifEmpty:[^0 ].
	^total := allTasks 
		inject: 0
		into: [ :tot :ea | tot + ea donePts ].

! !

!XpMember methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:10'!
email
	^ email! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:03'!
email: aString
	email := aString! !

!XpMember methodsFor: 'accessing' stamp: 'test 2/26/2009 12:57'!
history

	^ nil! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/23/2014 08:55'!
history: anArray
"We don''t need it for member'"
	self shouldNotImplement
	
! !

!XpMember methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:03'!
initTasks
	tasks := OrderedCollection new! !

!XpMember methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:06'!
initUseCases
	useCases := OrderedCollection new! !

!XpMember methodsFor: 'initialization' stamp: 'RGA 10/29/2014 11:59'!
initialize

	super initialize.	
	self initTasks.
	self initUseCases.
	self role: self defaultRole.
	self email: ''	.
	self password: ''	
	
	
	! !

!XpMember methodsFor: 'calcul' stamp: 'RGA 11/7/2014 17:12'!
load
 " the load is the addition of all  tasks' estimate' "

	| total  allTasks	|
	self project ifNil:[ ^ 0].
	allTasks := self  tasks.
	allTasks  ifEmpty: [^0].
	total  := allTasks  inject: 0 into:[ :tot :ea | tot + ea estimatedPts ].
	^total! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:02'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		accessor: #done ;
		label: 'Ralis' ;
		priority: 25 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:02'!
magritteDescriptionEmail
	<magritteDescription>	
	^ MAStringDescription  new
		accessor: #email ;
		label: 'Courriel' ;
		priority: 11 ;
		beOptional ;
		addCondition: [ :value | (value ~= ' ') 
									and: [value size <= 20]]
		labelled: 'Courriel invalide ou > 20' ;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:42'!
magritteDescriptionLoad
	<magritteDescription>	
	^ MANumberDescription  new
		accessor: #load ;
		label: 'Points de charge' ;
		priority: 20 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 11/20/2014 07:44'!
magritteDescriptionNbTasks
	<magritteDescription>	
	^ MANumberDescription  new
		accessor: #nbTasks ;
		label: 'Nb Tches' ;
		priority: 18 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/23/2014 15:10'!
magritteDescriptionPassword
	<magritteDescription>		
	^ MAStringDescription  new
		accessor: #password ;
		label: 'Mot de passe ' ;
		priority: 12 ;
		beOptional ;
		addCondition: [ :value | (value ~= ' ') 
									and: [value size <= 20]]
		labelled: 'Mot de passe invalide ou > 20' ;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 11/20/2014 07:44'!
magritteDescriptionRole
	<magritteDescription>
	^ MASingleOptionDescription  new
		accessor: #role ;
		label: 'Rle' ;
		priority: 14 ;
		options: #(Programmeur ProgrammeurAnalyste Gestionnaire Coach Analyste Testeur);
		beRequired ;
		beSorted ;
		default: self defaultRole ;
		yourself
! !

!XpMember methodsFor: 'calcul' stamp: 'rga 3/22/2009 22:49'!
nbTasks

	^ self tasks size! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/29/2014 11:42'!
owner
	self shouldNotImplement! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/29/2014 11:42'!
owner: aMember
	self shouldNotImplement! !

!XpMember methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:12'!
password
	^ password! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:04'!
password: aString
	password := aString! !

!XpMember methodsFor: 'calcul' stamp: 'rga 1/6/2011 21:56'!
ptsLeft
	| aLoad aScore |
	aScore := self donePts.
	aLoad := self load.
	(aLoad >= 0 and: [ aScore >= 0 ]) ifFalse: [ ^ 0 ].
	^ aLoad - aScore! !

!XpMember methodsFor: 'actions' stamp: 'RGA 11/9/2014 21:25'!
removeSelf
	| lesMembres |
	lesMembres := project members . 
	lesMembres isEmptyOrNil 
		ifFalse:[ lesMembres remove: self ifAbsent:[]]! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/12/2009 21:01'!
role
	^ role! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:02'!
role: aString
	role := aString! !

!XpMember methodsFor: 'associations' stamp: 'rga 2/23/2009 16:10'!
tasks

	^ tasks! !

!XpMember methodsFor: 'associations' stamp: 'rga 1/6/2011 21:45'!
tasks: aTask

	 self tasks add: aTask! !

!XpMember methodsFor: 'associations' stamp: 'rga 2/23/2009 16:14'!
useCases
	
	^ useCases ! !

!XpMember methodsFor: 'associations' stamp: 'rga 1/6/2011 21:45'!
useCases:  aUseCase

	self useCases add: aUseCase! !

XpCommun subclass: #XpProject
	instanceVariableNames: 'useCases tasks tests releases iterations oldMembers members aCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpProject commentStamp: 'rga 1/9/2011 16:56' prior: 0!
A XpProject is composed of differents releases and members.

Instance Variables
	iterations:		<Object>
	members:		<Object>
	oldMembers:		<Object>
	releases:		<Object>
	tasks:		<Object>
	tests:		<Object>
	useCases:		<Object>

iterations
	- xxxxx

members
	- xxxxx

oldMembers
	- xxxxx

releases
	- xxxxx

tasks
	- xxxxx

tests
	- xxxxx

useCases
	- xxxxx
!

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:39'!
addToIterations: anIteration 
" we add the iteration to the project iterations "
	self iterations add: anIteration! !

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:36'!
addToMembers: aMember 
	self members add: aMember! !

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:39'!
addToReleases: aRelease 

 	self releases add: aRelease! !

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:40'!
addToTasks: aTask 

	self tasks add: aTask! !

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:40'!
addToTests: aTest 

	self tests add: aTest! !

!XpProject methodsFor: 'associations' stamp: 'RGA 11/6/2014 13:40'!
addToUseCases: aCase 

	self useCases add: aCase! !

!XpProject methodsFor: 'finding' stamp: 'RGA 11/7/2014 18:13'!
find: anObject byName: aName 
	    
	| aSelector |
	aSelector := self asCommand:  anObject.
	aSelector :=self perform: aSelector.
	^ aSelector detect: [ :ea | ea hisName = aName ]
		ifNone: [ nil ]! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/7/2011 15:34'!
findMemberNamed: aName 
	^ self members 
		detect: [ :ea | ea hisName = aName ]
		ifNone: [ nil ]! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/10/2011 14:29'!
findTask: aTask
	

	^ self tasks detect: [ :ea | ea == aTask] ifNone:[].
! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/7/2011 15:35'!
findUseCase: aCase
	

	^  self useCases detect: [ :ea | ea = aCase] ifNone:[nil]! !

!XpProject methodsFor: 'finding' stamp: 'RGA 11/6/2014 20:06'!
findUseCaseNamed: aName 
	^ self useCases 
		detect: [ :ea | ea hisName = aName ]
		ifNone: [ nil ]! !

!XpProject methodsFor: 'accessing' stamp: 'test 2/26/2009 12:56'!
history
"We don''t need it for project'"
	^ nil! !

!XpProject methodsFor: 'accessing' stamp: 'test 2/26/2009 12:56'!
history: anArray
"We don''t need it for project'"
	^ nil! !

!XpProject methodsFor: 'initialization' stamp: 'rga 1/7/2011 15:11'!
initialize
	super initialize.
	self initializeCollections.
	self project: self.! !

!XpProject methodsFor: 'initialization' stamp: 'rga 1/7/2011 15:10'!
initializeCollections
	useCases := OrderedCollection new.
	members := OrderedCollection new.
	oldMembers := OrderedCollection new.
	tasks := OrderedCollection new.
	tests := OrderedCollection new.
	releases := OrderedCollection new.
	iterations := OrderedCollection new.
! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/17/2009 12:15'!
iterations
	^ iterations! !

!XpProject methodsFor: 'accessing' stamp: 'RGA 10/23/2014 09:02'!
iterations: anIteration
	
self flag:#revoir.! !

!XpProject methodsFor: 'finding' stamp: 'rga 12/5/2009 10:48'!
listNames: aCollection
	^aCollection collect:[ :ea | ea hisName] 
	! !

!XpProject methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:03'!
magritteDescriptionHisName
	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #hisName ;
		label: 'Projet' ;
		priority: 10 ;
		beRequired  ;
		addCondition: [ :value | (value size <= 24)]
		labelled: 'Le nom est trop long' ;
		yourself! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/3/2010 04:13'!
members
	^ members! !

!XpProject methodsFor: 'creation' stamp: 'rga 1/7/2011 15:43'!
newIteration
	| anIteration |
	anIteration := XpIteration new.
	anIteration history: anIteration newHistory.
	self addToIterations: anIteration.
	^ anIteration! !

!XpProject methodsFor: 'creation' stamp: 'rga 2/11/2010 15:51'!
newMember
"used exclusively for tests or dataTest."
	| aMember |
	aMember := XpMember new.
	self addToMembers: aMember.
	^ aMember! !

!XpProject methodsFor: 'creation' stamp: 'rga 1/7/2011 15:43'!
newRelease
	| aRel |
	aRel := XpRelease new.
	aRel history: aRel newHistory.
	self addToReleases: aRel.
	^ aRel! !

!XpProject methodsFor: 'creation' stamp: 'rga 1/7/2011 15:43'!
newTask
	| aTask |
	aTask := XpTask new.
	aTask history: aTask newHistory.
	self addToTasks: aTask.
	^ aTask! !

!XpProject methodsFor: 'creation' stamp: 'rga 1/7/2011 15:43'!
newTest
	| aTest |
	aTest := XpTest new.
	aTest history: aTest newHistory.
	self addToTests: aTest.
	^ aTest! !

!XpProject methodsFor: 'creation' stamp: 'rga 1/7/2011 15:43'!
newUseCase
	| aCase |
	aCase := XpUseCase new.
	aCase history: aCase newHistory.
	self addToUseCases: aCase.
	^ aCase! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/25/2009 10:41'!
oldMembers
	^ oldMembers! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/7/2011 15:17'!
oldMembers: anObject
	self oldMembers add: anObject! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/17/2009 11:11'!
releases
	^ releases! !

!XpProject methodsFor: 'private' stamp: 'rga 1/7/2011 15:37'!
removeMember: aMember 
	"Here the endDate is a noMoreActiveDate"
	aMember endDate: Date today.
	self oldMembers add: aMember.
	self members 
		remove: aMember
		ifAbsent: [  ]! !

!XpProject methodsFor: 'private' stamp: 'rga 1/7/2011 15:37'!
removeRelease: arelease

	self releases remove: arelease ! !

!XpProject methodsFor: 'private' stamp: 'rga 12/9/2009 10:38'!
removeSelf
	self shouldNotImplement! !

!XpProject methodsFor: 'private' stamp: 'rga 1/7/2011 15:37'!
removeTest: aTest

	self tests remove: aTest ! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/12/2009 17:00'!
tasks
	^ tasks! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/12/2009 17:00'!
tests
	^ tests! !

!XpProject methodsFor: 'accessing' stamp: 'RGA 11/6/2014 21:10'!
useCases
	^ useCases! !

XpCommun subclass: #XpRelease
	instanceVariableNames: 'capacityPts iterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpRelease commentStamp: 'rga 1/9/2011 16:56' prior: 0!
A XpRelease is composed of differents iterations.

Instance Variables
	capacityPts:		<Object>
	iterations:		<Object>

capacityPts
	- xxxxx

iterations
	- xxxxx
!

!XpRelease methodsFor: 'accessing' stamp: 'rga 2/17/2009 11:05'!
capacityPts
	^ capacityPts! !

!XpRelease methodsFor: 'accessing' stamp: 'rga 2/17/2009 11:05'!
capacityPts: anObject
	capacityPts := anObject! !

!XpRelease methodsFor: 'accessing' stamp: 'RGA 11/19/2014 18:08'!
done
"for display purpose"
		self load  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: [^(self donePts  / self load *100) truncated asString , ' % ']! !

!XpRelease methodsFor: 'accessing' stamp: 'RGA 11/19/2014 18:40'!
donePts
	| total |
	self iterations
		ifEmpty: [^ 0].
	total := self iterations
				inject: 0
				into: [:tot :ea | tot + ea donePts].
	^ total! !

!XpRelease methodsFor: 'initialization' stamp: 'rga 1/7/2011 11:38'!
initIterations

	 iterations := OrderedCollection new.
! !

!XpRelease methodsFor: 'initialization' stamp: 'rga 1/7/2011 11:38'!
initialize

	super initialize.
	self capacityPts: 0.
	self initIterations
! !

!XpRelease methodsFor: 'associations' stamp: 'rga 2/17/2009 11:05'!
iterations
	^ iterations! !

!XpRelease methodsFor: 'associations' stamp: 'RGA 11/7/2014 18:14'!
iterations: anIter

	self iterations add: anIter.
! !

!XpRelease methodsFor: 'actions' stamp: 'RGA 11/19/2014 17:36'!
load

	self iterations ifEmpty:[^0].
	^self iterations inject: 0 into:[ :tot :ea | tot + ea load].
! !

!XpRelease methodsFor: 'actions' stamp: 'RGA 11/19/2014 18:26'!
loadPercent
"for display purpose"
		self load  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: 
			[(self capacityPts / self load *100 ) truncated asString , '%']

! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:35'!
magritteDescriptionCapacity
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #capacityPts ;
		label: 'Capacit' ;
		priority: 60 ;
		default: 0;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:37'!
magritteDescriptionDone
	<magritteDescription>	
	^ MANumberDescription  new
		selectorAccessor: #done ;
		label: 'Ralis' ;
		priority: 75 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:03'!
magritteDescriptionLeft
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #ptsLeft ;
		label: 'Pts restants' ;
		priority: 80 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:36'!
magritteDescriptionLoad
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #load ;
		label: 'Charge' ;
		priority: 70 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'creation' stamp: 'rga 1/7/2011 15:51'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self capacityPts
		with: self load
		with: self done
		with: self ptsLeft	! !

!XpRelease methodsFor: 'accessing' stamp: 'RGA 11/19/2014 18:13'!
ptsLeft
	^ (self load isZero or: [ self donePts isZero ]) 
			ifTrue: [ 0 ]
			ifFalse: [ (self load - self donePts)  ]! !

!XpRelease methodsFor: 'associations' stamp: 'RGA 11/7/2014 23:49'!
removeIteration: anIteration

	^   iterations isEmptyOrNil 
		ifFalse: [self remove: anIteration  ifAbsent:[]]! !

!XpRelease methodsFor: 'actions' stamp: 'RGA 11/9/2014 21:24'!
removeSelf
	| lesLivrables |
	lesLivrables := project releases . 
	lesLivrables isEmptyOrNil 
		ifFalse:[ lesLivrables remove: self ifAbsent:[]]! !

XpCommun subclass: #XpTask
	instanceVariableNames: 'estimatedPts owner donePts status useCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpTask methodsFor: 'accessing' stamp: 'rga 2/17/2009 15:55'!
donePts
	^ donePts! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/17/2009 15:55'!
donePts: anInteger 
	donePts := anInteger! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/23/2009 15:34'!
endDate: aDateObject
	endDate := aDateObject.
	self status: 'Done'! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/13/2009 09:48'!
estimatedPts
	^ estimatedPts! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/13/2009 09:48'!
estimatedPts: anInteger 
	estimatedPts := anInteger! !

!XpTask methodsFor: 'testing' stamp: 'RGA 11/7/2014 19:05'!
hasRealDeveloper
	^ (self owner notNil) and: [owner hisName ~= 'Bidon']
	! !

!XpTask methodsFor: 'initialization' stamp: 'RGA 10/29/2014 12:33'!
initialize

	super initialize.
	self estimatedPts: 0.
	self donePts: 0.
	self status: 'To-Do'.
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionDonePts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #donePts ;
		label: 'Pts raliss' ;
		priority: 80 ;
		default: 0 ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionEstimatedPts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #estimatedPts ;
		label: 'Pts estims' ;
		priority: 70 ;
		default: 0 ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionLeft
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #ptsLeft ;
		label: 'Pts restants' ;
		priority: 90 ;
		beReadonly ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 19:17'!
magritteDescriptionOwnerName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #ownerName ;
		label: 'Nom du responsable' ; 
		priority: 40 ;
		options: self membersNamesList;
		beSorted;
		default: '--' ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ;
		priority: 30 ;
		default: '' ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 23:27'!
magritteDescriptionUseCase
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #useCaseName ;
		label: 'Cas d''utilisation' ; 
		priority: 20 ;
		options: self useCasesNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself! !

!XpTask methodsFor: 'actions' stamp: 'rga 1/7/2011 22:49'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self estimatedPts
		with: self donePts! !

!XpTask methodsFor: 'testing' stamp: 'RGA 11/8/2014 23:50'!
ownerName: aName 

	| aTeamMember |
	self projectExist ifTrue:[
	aTeamMember := self project members anyOne .
	aTeamMember := self project find: aTeamMember byName: aName].
	aTeamMember ifNotNil:
		[  aTeamMember tasks: self.
		  self owner: aTeamMember.]
	! !

!XpTask methodsFor: 'calcul' stamp: 'RGA 11/19/2014 17:29'!
ptsLeft
	^ (self estimatedPts isZero or: [ self donePts isZero ]) 
			ifTrue: [ 0 ]
			ifFalse: [ (self estimatedPts - donePts)  ]
! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/19/2014 09:15'!
ptsLeft: an
"MagritteDescription exige a writeSelector meme si on ne l'utilise pas"! !

!XpTask methodsFor: 'actions' stamp: 'RGA 11/9/2014 21:27'!
removeSelf
	| lesTaches |
	lesTaches := project tasks  . 
	lesTaches isEmptyOrNil 
		ifFalse:[ lesTaches remove: self ifAbsent:[]]! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/23/2009 15:08'!
startDate: aDateObject
	startDate := aDateObject.
	self status: 'In-Progress'! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/1/2014 21:51'!
status
"Le status est gnr par date de dbut, de fin, etc....chercher les 'Senders'"
	^ status! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/1/2014 21:51'!
status: anObject
"Le status est gnr par date de dbut, de fin, etc....chercher les 'Senders'"
	status := anObject! !

!XpTask methodsFor: 'associations' stamp: 'rga 2/24/2009 17:33'!
useCase
	^ useCase! !

!XpTask methodsFor: 'associations' stamp: 'rga 2/24/2009 17:33'!
useCase: anObject
	useCase := anObject! !

!XpTask methodsFor: 'associations' stamp: 'RGA 11/19/2014 17:32'!
useCaseName 
	^ useCase isNil 
		ifTrue:[ 'aucun'] 
		ifFalse:[useCase hisName ]! !

!XpTask methodsFor: 'associations' stamp: 'RGA 11/8/2014 23:54'!
useCaseName: aName

	| aUseCase |
	self projectExist ifTrue:[
	aUseCase := self project useCases  anyOne .
	aUseCase := self project find: aUseCase byName: aName].
	aUseCase ifNotNil:
		[  aUseCase tasks: self.
		  self useCase: aUseCase.]
	! !

XpCommun subclass: #XpTest
	instanceVariableNames: 'status useCase owner'
	classVariableNames: 'Status'
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpTest methodsFor: 'queries' stamp: 'rga 2/17/2009 14:46'!
allStatus

	^ #('Not-Passed' 'Passed')! !

!XpTest methodsFor: 'initialization' stamp: 'rga 1/7/2011 17:13'!
initialize

	super initialize.
	self status: 'Not-Passed'.
! !

!XpTest methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ;
		priority: 90 ;
		default: ' venir' ;
		yourself
! !

!XpTest methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 23:58'!
magritteDescriptionUseCase
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #useCaseName ;
		label: 'Cas d''utilisation' ; 
		priority: 20 ;
		options: self useCasesNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself! !

!XpTest methodsFor: 'queries' stamp: 'rga 1/7/2011 17:15'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self status
! !

!XpTest methodsFor: 'as yet unclassified' stamp: 'RGA 11/9/2014 21:27'!
removeSelf
	| lesTests |
	lesTests := project tests  . 
	lesTests isEmptyOrNil 
		ifFalse:[ lesTests remove: self ifAbsent:[]]! !

!XpTest methodsFor: 'accessing' stamp: 'rga 2/17/2009 14:27'!
status
	^ status! !

!XpTest methodsFor: 'accessing' stamp: 'rga 2/17/2009 14:27'!
status: aString
	 status := aString! !

!XpTest methodsFor: 'associations' stamp: 'rga 2/24/2009 18:06'!
useCase
	^ useCase! !

!XpTest methodsFor: 'associations' stamp: 'RGA 11/9/2014 00:14'!
useCase: anObject
		useCase := anObject! !

!XpTest methodsFor: 'associations' stamp: 'RGA 11/9/2014 21:05'!
useCaseName
 	^ self useCase ifNotNil:[ self useCase hisName]! !

!XpTest methodsFor: 'associations' stamp: 'RGA 11/9/2014 00:20'!
useCaseName: aName

	| aUseCase |
	self projectExist ifTrue:[
	aUseCase := self project useCases  anyOne .
	aUseCase :=( self project find: aUseCase byName: aName)].
	aUseCase ifNotNil:
		[  aUseCase tests: self.
		  self useCase: aUseCase.]
	! !

XpCommun subclass: #XpUseCase
	instanceVariableNames: 'owner iteration risk priority estimatedPts status tasks tests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpUseCase commentStamp: 'rga 1/9/2011 16:48' prior: 0!
A XpUseCase is broken down in (0/n) tasks and (0/n) tests .

Instance Variables
	estimatedPts:		<Object>
	iteration:		<Object>
	owner:		<Object>
	priority:		<Object>
	risk:		<Object>
	status:		<Object>
	tasks:		<Object>
	tests:		<Object>

estimatedPts
	- xxxxx

iteration
	- xxxxx

owner
	- xxxxx

priority
	- xxxxx

risk
	- xxxxx

status
	- xxxxx

tasks
	- xxxxx

tests
	- xxxxx
!

!XpUseCase methodsFor: 'accessing' stamp: 'rga 6/19/2009 17:17'!
donePts

	| total 	|
	tasks ifEmpty:[^0].
	total := tasks inject: 0 into:[ :tot :ea | tot + ea donePts].
	^total			
! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
estimatedPts
	^ estimatedPts! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
estimatedPts: anObject
	estimatedPts := anObject! !

!XpUseCase methodsFor: 'initialization' stamp: 'RGA 11/7/2014 19:10'!
initialize

	super initialize.
	self status: ' faire'.
	self initializeCollections.
! !

!XpUseCase methodsFor: 'initialization' stamp: 'RGA 11/7/2014 19:11'!
initializeCollections
		tasks := OrderedCollection new.
		tests := OrderedCollection new.! !

!XpUseCase methodsFor: 'associations' stamp: 'RGA 11/7/2014 19:13'!
iteration
	^ iteration ! !

!XpUseCase methodsFor: 'associations' stamp: 'RGA 11/8/2014 00:15'!
iteration: anIterName

	| iterationObject |
	iterationObject := self project iterations.
	iterationObject isEmptyOrNil 
		ifFalse: [
			iterationObject := iterationObject anyOne.
			iterationObject= (self project  find: iterationObject  byName: anIterName ). 	
			iterationObject notNil ifTrue: [
				iterationObject useCases: self.
				iteration := iterationObject]]! !

!XpUseCase methodsFor: 'associations' stamp: 'RGA 11/19/2014 14:37'!
iterationName
	iteration  isNil  
	ifFalse: [^ iteration hisName ] ! !

!XpUseCase methodsFor: 'associations' stamp: 'RGA 11/8/2014 23:21'!
iterationName: anIterName

	| iterationObject |
	self projectExist ifTrue: [
		iterationObject := self project iterations anyOne .
		iterationObject= (self project  find: iterationObject  byName: anIterName )]. 	
		iterationObject notNil ifTrue: [
				iterationObject useCases: self.
				iteration := iterationObject]! !

!XpUseCase methodsFor: 'actions' stamp: 'rga 4/19/2009 11:50'!
load

	| total 	|
	tasks ifEmpty:[^0].
	total := tasks inject: 0 into:[ :tot :ea | tot + ea estimatedPts].
	^total			
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #donePts ;
		label: 'Pts raliss' ;
		priority: 65 ;
		default: 0 ;
		beReadonly;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionEstimatedPts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #estimatedPts ;
		label: 'Pts estims' ;
		priority: 60 ;
		default: 0 ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 23:16'!
magritteDescriptionIterationName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #iterationName ;
		label: 'Itration' ; 
		priority: 20 ;
		options: self iterationsNamesList;
		beSorted;
		default: 'Non-assigne' ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 19:17'!
magritteDescriptionOwnerName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #ownerName ;
		label: 'Nom du responsable' ; 
		priority: 26 ;
		options: self membersNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 23:32'!
magritteDescriptionPriority
	<magritteDescription>
	^ MASingleOptionDescription   new
		selectorAccessor: #priority ;
		label: 'Priorit' ;
		options: #( 'Essentiel' 'Requis' 'Souhait') ;
		priority: 24 ;
		beRequired ;
		beSorted;
		default: 'Souhait' ;
		yourself! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 23:39'!
magritteDescriptionRisk
	<magritteDescription>
	^ MASingleOptionDescription   new
		selectorAccessor: #risk  ;
		label: 'Risque ' ;
		options: #( 'lev' 'Moyen' 'Bas') ;
		priority: 20 ;
		beRequired ;
		beSorted;
		default: 'Bas' ;
		yourself! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>	
	^ MASingleOptionDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ; 
		options: #( ' faire' 'En cours' 'Termin') ;
		priority: 22 ;
		beRequired ;
		beSorted;
		default: ' faire' ;
		yourself
! !

!XpUseCase methodsFor: 'actions' stamp: 'rga 1/7/2011 22:51'!
newHistory

	^Array 
		with: Date today
		with: startDate
		with: estimatedPts
		with: self load
		with: self donePts
! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
priority
	^ priority! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
priority: anObject
	priority := anObject! !

!XpUseCase methodsFor: 'actions' stamp: 'RGA 11/9/2014 21:28'!
removeSelf
	| lesUseCases |
	lesUseCases := project useCases  . 
	lesUseCases isEmptyOrNil 
		ifFalse:[ lesUseCases remove: self ifAbsent:[]]! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
risk
	^ risk! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
risk: anObject
	risk := anObject! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
status
	^ status! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
status: anObject
	status := anObject! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tasks
	^ tasks! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tasks: aTask
	tasks  add: aTask! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tests
	^ tests! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tests: aTest
	tests add: aTest! !

!XpUseCase methodsFor: 'accessing' stamp: 'RGA 11/6/2014 19:32'!
useCaseName
	^ self hisName ! !

Object subclass: #XpImageDB
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex XpProjectData'
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:51'!
project

	^ self xpProjectData! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:53'!
project: aProject

	self xpProjectData: aProject! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:31'!
reset

	Users := OrderedCollection new! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/18/2009 17:58'!
users

	^ Users ifNil: [ Users := OrderedCollection new ]! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/18/2009 17:59'!
users: anObject

	 Users := anObject! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/18/2009 17:59'!
writeMutex

	^ WriteMutex  ifNil: [ WriteMutex := Monitor new]! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/18/2009 18:00'!
writeMutex: anObject

	WriteMutex := anObject! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/22/2009 09:50'!
xpProjectData

	^ XpProjectData! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/22/2009 09:50'!
xpProjectData: aProject

	XpProjectData := aProject! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 1/3/2010 04:13'!
addMember: aMember 
	self class members add: aMember.
	self saveImage.
	^ aMember! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:05'!
addTask: aTask toUser: aUser

^ nil! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:06'!
addUser: aUser
	self class users add: aUser.
	self saveImage.
	^ aUser! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:05'!
addWork: aWork toUser: aUser

	aUser works: aWork.
	self saveImage.
	^aWork! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:07'!
connectionFailed

	^ false! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:07'!
disconnect

! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/19/2009 11:19'!
findUserByEmail: aMail

	^ self  class users
		detect: [ :each | each email = aMail ] 
		ifNone:[ nil]! !

!XpImageDB methodsFor: 'initialize-release' stamp: 'RGA 10/28/2014 13:03'!
initialize
	super initialize.
! !

!XpImageDB methodsFor: 'lazzy-initialization' stamp: 'RGA 10/28/2014 13:24'!
project

	^ self class project ifNil:[ self class project: (XpProject new hisName: 'PremierProjet').]! !

!XpImageDB methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:53'!
project: aProject

	self class project: aProject! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:10'!
reset

	self class reset! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:10'!
save: anObject! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:11'!
saveImage

	self class writeMutex critical: [ self saveImageWithoutMonitor]! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:12'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession! !

Object subclass: #XpMagmaDB
	instanceVariableNames: 'session'
	classVariableNames: 'MagmaSession'
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpMagmaDB methodsFor: 'user management' stamp: 'rga 3/10/2009 10:25'!
addUser: aUser

	self session commit: [ self users add: aUser].
	^ aUser! !

!XpMagmaDB methodsFor: 'stuff' stamp: 'rga 3/17/2009 18:32'!
connect

	self session: (MagmaSession
		host: self localhost
		port: self defaultPort).
	self session connectAs: 'aXpProcess'! !

!XpMagmaDB methodsFor: 'as yet unclassified' stamp: 'rga 3/10/2009 10:26'!
createUsers
	self session commit: [ self session root
		at: 'users'
		put: OrderedCollection new]! !

!XpMagmaDB methodsFor: 'defaults' stamp: 'rga 3/10/2009 10:21'!
defaultPort

	^ 51001! !

!XpMagmaDB methodsFor: 'connection open/close' stamp: 'rga 3/17/2009 22:19'!
disconnect

	self session 
		disconnect;
		closeRepository.
	self session: nil! !

!XpMagmaDB methodsFor: 'initialization' stamp: 'rga 3/10/2009 10:23'!
initialize

	self connect! !

!XpMagmaDB methodsFor: 'as yet unclassified' stamp: 'rga 3/17/2009 22:18'!
localHost

^ 'Macintosh.local '
"	^ #(127 0 0 1) asByteArray"! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:58'!
session
	^ session! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:58'!
session: anObject
	session := anObject! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:27'!
users

	^ self session root
		at: 'users'
		ifAbsent: [ self error: 'La Base de Donnes n''est pas initialise']! !

MAReport subclass: #MAReportXp
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Report'!

!MAReportXp commentStamp: 'RGA 11/20/2014 17:27' prior: 0!
MAReportXp is a subclass a MAReport that I created because I needed an instance variable that does not exist in MAReport

Instance Variables:
	title	<to give a title on each table >!

!MAReportXp methodsFor: '*xpprocess' stamp: 'RGA 11/20/2014 17:18'!
title
	^ title! !

!MAReportXp methodsFor: '*xpprocess' stamp: 'RGA 11/20/2014 17:18'!
title: anObject
	title := anObject! !

TestCase subclass: #XpIterationTest
	instanceVariableNames: 'iteration project release aUseCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpIterationTest methodsFor: 'running' stamp: 'rga 12/10/2009 14:07'!
setUp
	project := XpProject new.
	project newIteration.
	project newRelease.
	project newUseCase.
	aUseCase := project useCases last.
	iteration := project iterations last.
	release := project releases last! !

!XpIterationTest methodsFor: 'tests' stamp: 'test 2/26/2009 13:59'!
testIterationHistory
	self assert: iteration history notEmpty.
	self assert: iteration endDate = project iterations last endDate.
	self assert: (iteration history last at:1) = Date today.! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 1/6/2011 21:58'!
testIterationLeftPts
	self assert: (iteration ptsLeft =( iteration load - iteration done))! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 2/24/2009 10:51'!
testIterationRelease

	|  |
	iteration release: release.
	self assert: iteration release = release iterations last release.
! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 2/24/2009 10:53'!
testIterationStates

	
	self assert: iteration hisName = 'UnNamed'.
	self assert: iteration useCases notNil.
	self assert: iteration useCases isEmpty.
! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 12/10/2009 14:02'!
testIterationUseCases

	self assert: iteration useCases isEmpty.
	iteration useCases: aUseCase.
	self assert: (iteration useCases includes: aUseCase).
! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:16'!
testIterationUseCasesRemoving
	| uCa |
	uCa := project newUseCase.
	self assert: (project useCases size = 2).
	self 
		assert: (project useCases includes: uCa).
	project useCases remove: uCa.
	self deny: (project useCases includes: uCa)! !

!XpIterationTest methodsFor: 'tests' stamp: 'rga 2/25/2010 21:57'!
testIterationsRemoving
	| aIter |
	aIter := project newIteration.
	self assert: (project iterations size = 2).
	self 
		assert: (project iterations
		includes: aIter).
	project iterations remove: aIter.
	self deny: (project iterations includes: aIter)! !

TestCase subclass: #XpMemberTest
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpMemberTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 1/3/2010 04:13'!
testMemberAdding
	| aMember bMember |
	aMember := project newMember.
	bMember := project newMember.
	self assert: (project members includes: aMember).
	self assert: (project members includes: bMember).
	self assert: project members size = 2! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 1/3/2010 04:13'!
testMemberAssignedProject
	| aMember |
	project newMember.
	aMember := project members anyOne.
	self deny: aMember project isNil.
	project addToMembers: aMember.
	self assert: project members anyOne project == project! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 1/6/2011 21:59'!
testMemberPoints
	| aTask aMember bMember |
	project newMember.
	project newMember.
	aMember := project members first.
	bMember := project members last.
	project newTask.
	aTask := project tasks last.
	aTask donePts: 5.
	aTask estimatedPts: 7.
	project newTask.
	aTask := project tasks first.
	aTask donePts: 3.
	aTask estimatedPts: 9.
	self assert: aMember donePts = (aMember load - aMember ptsLeft).
	self assert: aMember ptsLeft = (aMember load - aMember donePts).
	self assert: bMember donePts = (bMember load - bMember ptsLeft).
	self assert: bMember ptsLeft = (bMember load - bMember donePts)! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:12'!
testMemberRemoving
	| aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	bMember := project members last.
	project removeMember: aMember.
	self assert: project members size = 1.
	self 
		assert: (project oldMembers includes: aMember).
	self deny: (project members includes: aMember).
	self assert: (project members includes: bMember)! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 1/7/2011 22:57'!
testMemberStates
	| aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	bMember := project members last.
	self assert: aMember hisName = aMember defaultName.
	self assert: bMember role = aMember defaultRole.
	self assert: aMember note = aMember defaultNote.
	self assert: bMember project == project.
	self assert: aMember email notNil.
	self assert: bMember password notNil! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2009 11:16'!
testMemberTasksAssigned

	 | aMember bMember firstTask secondTask |
	aMember := project newMember.
	bMember := project newMember.
	firstTask := project newTask.
	secondTask := project newTask.
	aMember tasks: firstTask.
	aMember tasks: secondTask.
	self assert: aMember tasks size =2.
	self assert: bMember tasks isEmpty.! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2009 11:19'!
testMemberUseCasesAssigned

	 | aMember bMember   aUCase bUCase |
	aMember := project newMember.
	bMember := project newMember.
	aUCase := project newUseCase.
	bUCase := project newUseCase.
	aMember useCases: aUCase.
	aMember useCases: bUCase.
	self assert: aMember useCases size =2.
	self assert: bMember useCases isEmpty.! !

TestCase subclass: #XpProjectTest
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpProjectTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:06'!
testListIterationsNames
	| aIter bIter namesList |
	project newIteration ; newIteration ; newIteration.
	aIter := project iterations first.
	bIter := project iterations last.
	aIter hisName: 'Livrable-1'.
	bIter hisName: 'Livrable-2'.
	namesList := project listNames: project iterations.
	self assert: namesList size = 3.
	self 
		assert: (namesList
		includes: bIter hisName).
	self 
		assert: (namesList
		includes: aIter hisName).
	self 
		assert: (namesList
		includes: 'UnNamed')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/7/2011 22:48'!
testListMembersNames
	| aMember bMember namesList |
	project
		newMember;
		newMember;
		newMember.
	aMember := project members first.
	aMember hisName: 'Joseph'.
	bMember := project members last.
	bMember hisName: 'Pauline'.
	namesList := project listNames: project members.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bMember hisName).
	self 
		assert: (namesList
		includes: aMember hisName).
	self 
		assert: (namesList
		includes: 'UnNamed')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:09'!
testListReleasesNames
	| aRelease bRelease namesList |
	project newRelease ; newRelease ; newRelease.
	aRelease := project releases first.
	aRelease hisName: 'Livrable-1'.
	bRelease := project releases last.
	bRelease hisName: 'Livrable-2'.
	namesList := project listNames: project releases.
	self assert: namesList size = 3.
	self assert: (namesList  includes: bRelease hisName).
	self assert: (namesList includes: aRelease hisName).
	self assert: (namesList includes: 'UnNamed')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:09'!
testListTasksNames
	| aTask bTask namesList |
	project newTask ; newTask ; newTask.
	aTask := project tasks first.
	aTask hisName: 'T1'.
	bTask := project tasks last.
	bTask hisName: 'T2'.
	namesList := project listNames: project tasks.
	self assert: namesList size =3.
	self assert: (namesList includes: bTask hisName).
	self assert: (namesList includes: aTask hisName).
	self assert: (namesList includes: 'UnNamed').
! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:10'!
testListTests
	| aTest bTest namesList |
	project newTest ; newTest; newTest.
	aTest := project tests first.
	aTest hisName: 'Test-1'.
	bTest := project tests last.
	bTest hisName: 'Test-2'.
	namesList := project listNames: project tests.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bTest hisName).
	self 
		assert: (namesList includes: aTest hisName).
	self 
		assert: (namesList includes: 'UnNamed')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:11'!
testListUseCases
	| aUCase bUCase namesList  |
	project newUseCase ; newUseCase ; newUseCase.
	aUCase := project useCases first.
	aUCase hisName: 'Ouvrir un fichier'.
	bUCase := project useCases last.
	bUCase hisName: 'Sauvegarder la base'.
	namesList := project listNames: project useCases.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bUCase hisName).
	self 
		assert: (namesList includes: aUCase hisName).
	self 
		assert: (namesList includes: 'UnNamed').! !

!XpProjectTest methodsFor: 'tests' stamp: 'RGA 11/7/2014 17:50'!
testMemberFinding
	| fMemberName aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	aMember hisName: 'Joseph'.
	bMember := project members last.
	bMember hisName: 'Pauline'.
	fMemberName := project find: bMember  byName: bMember hisName.
	self assert: fMemberName notNil.
	self deny: aMember = fMemberName.
	self assert: bMember = fMemberName.
	self assert: project members size = 2! !

!XpProjectTest methodsFor: 'running' stamp: 'rga 1/3/2010 04:13'!
testProjectCreations
	| aMember aRelease aTask aUseCase aTest anIteration |
	aMember := project newMember.
	aRelease := project newRelease.
	aTask := project newTask.
	aUseCase := project newUseCase.
	aTest := project newTest.
	anIteration := project newIteration.
	self assert: project members notEmpty.
	self assert: project releases notEmpty.
	self assert: project tasks notEmpty.
	self assert: project useCases notEmpty.
	self assert: project tests notEmpty.
	self assert: project iterations notEmpty.
	self assert: project iterations anyOne project = project.
	self assert: project useCases anyOne project = project.
	self assert: project members anyOne project = project.
	self assert: project releases anyOne project = project.
	self assert: project tests anyOne project = project.
	self assert: project tasks anyOne project = project! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/7/2011 22:53'!
testProjectStates
	| instVars |
	instVars := #(
		'id'
		'hisName'
		'note'
		'project'
		'startDate'
		'endDate'
		'history'
		'useCases'
		'tasks'
		'tests'
		'releases'
		'iterations'
		'oldMembers'
		'members'
	).
	self assert: project hisName notNil.
	self assert: project startDate <= Date today.
	self assert: project useCases isEmpty.
	self assert: project members isEmpty.
	self assert: project oldMembers isEmpty.
	self assert: project tasks isEmpty.
	self assert: project tests isEmpty.
	self assert: project releases isEmpty.
	self assert: project iterations isEmpty.
	self assert: instVars size = project class allInstVarNames size.
	self assert: project endDate = nil! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/23/2009 15:15'!
testProjectTasksFinding
	| firstTask secondTask foundTask aName |
	project newTask ; newTask.
	firstTask := project tasks first.
	secondTask := project tasks second.
	aName := 'The first one'.
	firstTask hisName: aName.
	secondTask hisName: 'The second one'.
	self assert: project tasks size = 2.
	self assert: project tasks first = firstTask.
	self assert: project tasks second = secondTask.
	foundTask := project findTask: firstTask.
	self assert: foundTask notNil.
	self assert: foundTask hisName = aName! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/23/2009 16:28'!
testProjectUseCaseFinding
	| firstCase secondCase aName foundCase |
	project newUseCase ; newUseCase.
	firstCase := project useCases first.
	secondCase := project useCases second.
	aName := 'The first one'.
	firstCase hisName: aName.
	secondCase hisName: 'The second one'.
	self assert: project useCases size = 2.
	self assert: project useCases first = firstCase.
	self assert: project useCases second = secondCase.
	foundCase := project findUseCase: firstCase.
	self assert: foundCase notNil.
	self assert: foundCase hisName = aName! !

TestCase subclass: #XpReleaseTest
	instanceVariableNames: 'project myRelease myIteration myUseCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpReleaseTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new.
	project
		newRelease;
		newIteration;
		newUseCase.
	myRelease := project releases first.
	"	myRelease endDate: Date today.
"
	myIteration := project iterations first.
	myUseCase := project useCases first! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:17'!
testReleaseAssociations
	| aProjectRelease |
	myIteration release: myRelease.
	self assert: myIteration release = myRelease.
	aProjectRelease := project releases anyOne.
	self assert: (aProjectRelease iterations includes: myIteration).
	myUseCase iteration: myIteration.
	self assert: myIteration useCases notEmpty.
	self assert: (myIteration useCases includes: myUseCase).
! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 6/19/2009 17:22'!
testReleaseDonePts

	| bUCase aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	bUCase := project newUseCase.
	myUseCase estimatedPts: 8.
	myUseCase tasks: aTask.
	bUCase estimatedPts: 5.
	bUCase tasks: bTask.
	myIteration useCases: myUseCase.	
	myIteration useCases: bUCase.
	myRelease iterations: myIteration.
	self assert: myRelease donePts =6! !

!XpReleaseTest methodsFor: 'tests' stamp: 'test 2/26/2009 13:57'!
testReleaseHistory
	self assert: myRelease history notEmpty.
	self assert: myRelease endDate = project releases last endDate.
	self assert: (myRelease history last at:1) = Date today.! !

!XpReleaseTest methodsFor: 'running' stamp: 'rga 2/25/2010 22:18'!
testReleaseIterationRemoving


	| aRel aIter bIter |
	aRel := project newRelease.
	aIter := project newIteration.
	bIter := project newIteration.
	aRel iterations: aIter.
	aRel iterations: bIter.
	self assert: (aRel iterations includes: bIter).
	self assert: aRel iterations size =2.
	aRel removeIteration: bIter.
	self deny: (aRel iterations includes: bIter)
! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 2/25/2009 14:27'!
testReleaseLoad

	| bUCase aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	bUCase := project newUseCase.
	myUseCase estimatedPts: 8.
	myUseCase tasks: aTask.
	bUCase estimatedPts: 5.
	bUCase tasks: bTask.
	myIteration useCases: myUseCase.	
	myIteration useCases: bUCase.
	myRelease iterations: myIteration.
	" release load = estimatedPts of allUseCases of allIteration composing a release"
	self assert: myRelease load =13! !

!XpReleaseTest methodsFor: 'running' stamp: 'rga 2/25/2010 22:18'!
testReleaseRemoving


	| aRel |
	aRel := project newRelease.
	self assert: project releases size = 2.
	self assert: (project releases includes: aRel).
	project releases remove: aRel.
	self deny: (project releases includes: aRel).! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 2/24/2009 16:21'!
testReleaseStates
	| projectRelease   |
	myRelease capacityPts: 23.
	self assert: project releases notEmpty.
	projectRelease := project releases anyOne.
	self assert: myRelease hisName = 'UnNamed'.
	self assert: projectRelease hisName = 'UnNamed'.
	self assert: projectRelease = myRelease.
	self assert: projectRelease iterations notNil.
	self assert: projectRelease capacityPts = myRelease capacityPts.
	self assert: myRelease project = project! !

TestCase subclass: #XpTaskTest
	instanceVariableNames: 'project firstTask secondTask thirdTask uCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpTaskTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new.
	project
		newTask;
		newTask;
		newUseCase.
	firstTask := project tasks first.
	secondTask := project tasks second.
	uCase := project useCases anyOne! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:22'!
testTaskCreationDelete

	firstTask  hisName: 'The first one'.
	secondTask hisName: 'The second one'.
	self assert: project tasks size = 2.
	self assert: project tasks first = firstTask.
	self assert: project tasks second = secondTask.
	project tasks remove: firstTask.
	self assert: project tasks size = 1.
	self deny: (project tasks includes: firstTask)! !

!XpTaskTest methodsFor: 'tests' stamp: 'test 2/26/2009 14:04'!
testTaskHistory
	self assert: firstTask history notEmpty.
	self assert: firstTask endDate = project tasks last endDate.
	self assert: (firstTask history last at:1) = Date today.! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:22'!
testTaskPts

	secondTask estimatedPts: 5.
	self assert: firstTask  estimatedPts = 0.
	self assert: secondTask estimatedPts = 5.
	self assert: firstTask donePts = 0.
! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 1/7/2011 23:06'!
testTaskStatus
	
	project newTask.
	thirdTask  := project tasks last.
	secondTask startDate: Date yesterday.
	thirdTask startDate: Date yesterday.
	thirdTask endDate: Date tomorrow.
	"Date new is  1 January 1901 "
	self assert: project tasks first startDate =project tasks first defaultStartDate.
	self assert: project tasks first endDate = project tasks first defaultEndDate.	
	self assert: project tasks first status = 'To-Do'.
	self deny:  project tasks second startDate = Date new.
	self assert: project tasks second status = 'In-Progress'.
	self deny: project tasks third startDate = Date new.
	self deny: project tasks third endDate = Date new.
	self assert: project tasks third status = 'Done'.

! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:19'!
testTaskUseCaseAssociation

	firstTask useCase: uCase.
	uCase owner = firstTask owner.
	self assert: firstTask useCase  = uCase.
	self assert: (project useCases includes: uCase).! !

TestCase subclass: #XpTestTest
	instanceVariableNames: 'project firstTest secondTest uCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpTestTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new.
	uCase := project newUseCase! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:46'!
testTestAdding

	project newTest ; newTest.
	firstTest := project tests first.
	secondTest := project tests last.
	self assert: (project tests includes: firstTest).
	self assert: (project tests includes: secondTest)! !

!XpTestTest methodsFor: 'tests' stamp: 'test 2/26/2009 14:17'!
testTestHistory

	firstTest := project newTest.	
	self assert: firstTest history notEmpty.
	self assert: firstTest endDate = project tests last endDate.
	self assert: (firstTest history last at:1) = Date today.! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/20/2009 17:45'!
testTestRemoving

	project newTest ; newTest.
	firstTest := project tests first.
	secondTest := project tests last.
	project removeTest: firstTest.
	self assert: (project tests size = 1).
	self deny: (project tests includes: firstTest).
	self assert: (project tests includes: secondTest)! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:26'!
testTestStatus

	| stats |
	project newTest.
	firstTest := project tests anyOne.
	stats := project tests anyOne allStatus.
	self assert: (project tests includes: firstTest).
	self assert: (firstTest status = 'Not-Passed').
	self assert: (stats includes: 'Not-Passed').
	self assert: (stats includes: 'Passed').! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:26'!
testTestUseCaseAssociation

	project newTest.
	firstTest := project tests anyOne.
	self assert: project useCases notEmpty.
	self assert: firstTest useCase = nil.
	self assert: uCase tests isEmpty.
	firstTest useCase: uCase .
	self assert: firstTest useCase notNil.
	self assert: (uCase tests includes: firstTest).! !

TestCase subclass: #XpUseCaseTest
	instanceVariableNames: 'project allPriorities allRisks uCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpUseCaseTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	allPriorities := #('Must-Have' 'Should-Have' 'Could-Have' ).
	allRisks := #('High' 'Medium' 'Low' ).
	project := XpProject new.
	project
		newUseCase;
		newMember;
		newIteration.
	uCase := project useCases anyOne! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 6/19/2009 17:21'!
testUseCaseDonePts

	| aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	uCase estimatedPts: 8.
	uCase tasks: aTask.
	uCase tasks: bTask.
	self assert: uCase donePts =6! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'test 2/26/2009 14:18'!
testUseCaseHistory

	self assert: uCase history notEmpty.
	self assert: uCase endDate = project useCases last endDate.
	self assert: (uCase history last at:1) = Date today.! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:27'!
testUseCaseIteration

	| iteration |
	iteration := project iterations anyOne.
	uCase iteration:  iteration.
	self assert: uCase iteration notNil.
	self assert: (iteration useCases includes: uCase).
! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 2/25/2009 14:38'!
testUseCaseLoad

	| aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	uCase estimatedPts: 8.
	uCase tasks: aTask.
	uCase tasks: bTask.
	self assert: uCase load =18! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 1/7/2011 23:10'!
testUseCaseOwner
	self assert: uCase owner first hisName = uCase owner first defaultName.
	uCase owner: project members anyOne.
	self assert: uCase owner notNil.
	self assert: uCase owner hisName = uCase owner  defaultName.! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:27'!
testUseCasePrioritiesAndRisks

	uCase priority: (allPriorities at: 1).
	uCase risk:( allRisks at: 1).
	self assert: (uCase risk = 'High').
	self assert: (uCase priority = 'Must-Have').
	self assert: (allRisks includes: 'Medium').
	self assert: (allRisks includes: 'Low').
	self assert: uCase risk = 'High'.
	self assert: uCase priority = 'Must-Have'.
	self assert: (allPriorities includes: 'Should-Have').
	self assert: (allPriorities includes: 'Could-Have').! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:28'!
testUseCaseRemoving
	| bCase |
	bCase := project newUseCase.
	self assert: project useCases size = 2.
	self assert: (project useCases includes: bCase).
	project useCases remove: bCase.
	self deny: (project useCases includes: bCase)! !
XpRootTask initialize!
